diff --git a/src/backend/optimizer/path/joinpath.c b/src/backend/optimizer/path/joinpath.c
index 4c30c65564..9a78e9ce10 100644
--- a/src/backend/optimizer/path/joinpath.c
+++ b/src/backend/optimizer/path/joinpath.c
@@ -527,12 +527,19 @@ get_resultcache_path(PlannerInfo *root, RelOptInfo *innerrel,
 									&param_exprs,
 									&hash_operators))
 	{
+		bool		singlerow;
+
+		if (!extra->inner_unique)
+			singlerow = false;
+		else
+			singlerow = list_length(extra->restrictlist) == list_length(inner_path->param_info->ppi_clauses);
+
 		return (Path *) create_resultcache_path(root,
 												innerrel,
 												inner_path,
 												param_exprs,
 												hash_operators,
-												extra->inner_unique,
+												singlerow,
 												outer_path->parent->rows);
 	}
 
